<!DOCTYPE html><html lang="zh-CN" data-theme="light"><head><meta charset="UTF-8"><meta http-equiv="X-UA-Compatible" content="IE=edge"><meta name="viewport" content="width=device-width,initial-scale=1"><title>keepalived+NFS+rsync高可用共享存储 | SeMaik</title><meta name="author" content="ZuSir"><meta name="copyright" content="ZuSir"><meta name="format-detection" content="telephone=no"><meta name="theme-color" content="#ffffff"><meta name="description" content="服务器信息   IP Hostname module    172.16.1.12 ServerOne nfs,rpcbind，两块或以上硬盘，keepalived，rsync+inotify   172.16.1.13 ServerTwo nfs,rpcbind,keepalived   172.16.1.14 client centos   部署NFS 请参考前面的文档,不用配置客户端  部署">
<meta property="og:type" content="article">
<meta property="og:title" content="keepalived+NFS+rsync高可用共享存储">
<meta property="og:url" content="http://example.com/2021/02/08/keepalived-NFS-rsyns%E9%AB%98%E5%8F%AF%E7%94%A8%E5%85%B1%E4%BA%AB%E5%AD%98%E5%82%A8/index.html">
<meta property="og:site_name" content="SeMaik">
<meta property="og:description" content="服务器信息   IP Hostname module    172.16.1.12 ServerOne nfs,rpcbind，两块或以上硬盘，keepalived，rsync+inotify   172.16.1.13 ServerTwo nfs,rpcbind,keepalived   172.16.1.14 client centos   部署NFS 请参考前面的文档,不用配置客户端  部署">
<meta property="og:locale" content="zh_CN">
<meta property="og:image" content="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg">
<meta property="article:published_time" content="2021-02-08T07:16:00.000Z">
<meta property="article:modified_time" content="2021-02-18T06:47:16.000Z">
<meta property="article:author" content="ZuSir">
<meta name="twitter:card" content="summary">
<meta name="twitter:image" content="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg"><link rel="shortcut icon" href="https://myit.icu/favicon.ico"><link rel="canonical" href="http://example.com/2021/02/08/keepalived-NFS-rsyns%E9%AB%98%E5%8F%AF%E7%94%A8%E5%85%B1%E4%BA%AB%E5%AD%98%E5%82%A8/"><link rel="preconnect" href="//cdn.jsdelivr.net"/><link rel="preconnect" href="//busuanzi.ibruce.info"/><link rel="stylesheet" href="/css/index.css"><link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@fortawesome/fontawesome-free/css/all.min.css" media="print" onload="this.media='all'"><script>const GLOBAL_CONFIG = { 
  root: '/',
  algolia: undefined,
  localSearch: undefined,
  translate: undefined,
  noticeOutdate: undefined,
  highlight: {"plugin":"highlighjs","highlightCopy":true,"highlightLang":true},
  copy: {
    success: '复制成功',
    error: '复制错误',
    noSupport: '浏览器不支持'
  },
  relativeDate: {
    homepage: true,
    post: false
  },
  runtime: '',
  date_suffix: {
    just: '刚刚',
    min: '分钟前',
    hour: '小时前',
    day: '天前',
    month: '个月前'
  },
  copyright: undefined,
  lightbox: 'fancybox',
  Snackbar: undefined,
  source: {
    jQuery: 'https://cdn.jsdelivr.net/npm/jquery@latest/dist/jquery.min.js',
    justifiedGallery: {
      js: 'https://cdn.jsdelivr.net/npm/justifiedGallery/dist/js/jquery.justifiedGallery.min.js',
      css: 'https://cdn.jsdelivr.net/npm/justifiedGallery/dist/css/justifiedGallery.min.css'
    },
    fancybox: {
      js: 'https://cdn.jsdelivr.net/npm/@fancyapps/fancybox@latest/dist/jquery.fancybox.min.js',
      css: 'https://cdn.jsdelivr.net/npm/@fancyapps/fancybox@latest/dist/jquery.fancybox.min.css'
    }
  },
  isPhotoFigcaption: false,
  islazyload: false,
  isanchor: false
}</script><script id="config-diff">var GLOBAL_CONFIG_SITE = { 
  isPost: true,
  isHome: false,
  isHighlightShrink: undefined,
  isToc: true,
  postUpdate: '2021-02-18 14:47:16'
}</script><noscript><style type="text/css">
  #nav {
    opacity: 1
  }
  .justified-gallery img {
    opacity: 1
  }

  #recent-posts time,
  #post-meta time {
    display: inline !important
  }
</style></noscript><script>(win=>{
    win.saveToLocal = {
      set: function setWithExpiry(key, value, ttl) {
        if (ttl === 0) return
        const now = new Date()
        const expiryDay = ttl * 86400000
        const item = {
          value: value,
          expiry: now.getTime() + expiryDay,
        }
        localStorage.setItem(key, JSON.stringify(item))
      },

      get: function getWithExpiry(key) {
        const itemStr = localStorage.getItem(key)

        if (!itemStr) {
          return undefined
        }
        const item = JSON.parse(itemStr)
        const now = new Date()

        if (now.getTime() > item.expiry) {
          localStorage.removeItem(key)
          return undefined
        }
        return item.value
      }
    }
  
    win.getScript = url => new Promise((resolve, reject) => {
      const script = document.createElement('script')
      script.src = url
      script.async = true
      script.onerror = reject
      script.onload = script.onreadystatechange = function() {
        const loadState = this.readyState
        if (loadState && loadState !== 'loaded' && loadState !== 'complete') return
        script.onload = script.onreadystatechange = null
        resolve()
      }
      document.head.appendChild(script)
    })
  
      const asideStatus = saveToLocal.get('aside-status')
      if (asideStatus !== undefined) {
        if (asideStatus === 'hide') {
          document.documentElement.classList.add('hide-aside')
        } else {
          document.documentElement.classList.remove('hide-aside')
        }
      }
    })(window)</script><link href="/css/style.css"><meta name="generator" content="Hexo 5.3.0"><link rel="alternate" href="/atom.xml" title="SeMaik" type="application/atom+xml">
</head><body><div id="web_bg"></div><div id="sidebar"><div id="menu-mask"></div><div id="sidebar-menus"><div class="author-avatar"><img class="avatar-img" src="/img/123.jpeg" onerror="onerror=null;src='/img/123.jpeg'" alt="avatar"/></div><div class="site-data"><div class="data-item is-center"><div class="data-item-link"><a href="/archives/"><div class="headline">文章</div><div class="length-num">152</div></a></div></div><div class="data-item is-center"><div class="data-item-link"><a href="/categories/"><div class="headline">分类</div><div class="length-num">37</div></a></div></div></div><hr/><div class="menus_items"><div class="menus_item"><a class="site-page" href="/"><i class="fa-fw fas fa-home"></i><span> 首页</span></a></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> Linux</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Linux/"><span> Linux</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> WEB</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Apache/"><span> Apache</span></a></li><li><a class="site-page" href="/categories/Nginx/"><span> Nginx</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 存储</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Ceph/"><span> Ceph</span></a></li><li><a class="site-page" href="/categories/NFS/"><span> NFS</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 日志</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Loki"><span> Loki</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 编程</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Shell"><span> Shell</span></a></li><li><a class="site-page" href="/categories/Python"><span> Python</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 高可用</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/KeepAlived/"><span> KeepAlived</span></a></li><li><a class="site-page" href="/categories/LVS/"><span> LVS</span></a></li><li><a class="site-page" href="/categories/Squid/"><span> Squid</span></a></li><li><a class="site-page" href="/categories/Haproxy/"><span> Haproxy</span></a></li><li><a class="site-page" href="/categories/Rsync/"><span> Rsync</span></a></li><li><a class="site-page" href="/categories/Memcache/"><span> Memcache</span></a></li><li><a class="site-page" href="/categories/Varnish/"><span> Varnish</span></a></li><li><a class="site-page" href="/categories/GRedis/"><span> Redis</span></a></li><li><a class="site-page" href="/categories/Rabbit/"><span> RabbitMQ</span></a></li><li><a class="site-page" href="/categories/Kafka/"><span> Kafka</span></a></li><li><a class="site-page" href="/categories/MHA/"><span> MHA</span></a></li><li><a class="site-page" href="/categories/PXC/"><span> PXC</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 虚拟化</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Docker/"><span> Docker</span></a></li><li><a class="site-page" href="/categories/Kubernetes/"><span> Kubernetes</span></a></li><li><a class="site-page" href="/categories/OpenStack/"><span> OpenStack</span></a></li><li><a class="site-page" href="/categories/KVM/"><span> KVM</span></a></li><li><a class="site-page" href="/categories/Containerd"><span> Containerd</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> Hexo</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Hexo/"><span> Hexo</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 数据库</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/MySQL/"><span> MySQL</span></a></li><li><a class="site-page" href="/categories/Readis/"><span> Readis</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 微服务</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Tomcat/"><span> Tomcat</span></a></li><li><a class="site-page" href="/categories/Git/"><span> Git</span></a></li><li><a class="site-page" href="/categories/Maven/"><span> Maven</span></a></li><li><a class="site-page" href="/categories/Nexus/"><span> Nexus</span></a></li><li><a class="site-page" href="/categories/Jenkins/"><span> Jenkins</span></a></li><li><a class="site-page" href="/categories/Spring/"><span> Spring</span></a></li><li><a class="site-page" href="/categories/Consul/"><span> Consul</span></a></li><li><a class="site-page" href="/categories/Harbor/"><span> Harbor</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 自动化</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Ansible/"><span> Ansible</span></a></li><li><a class="site-page" href="/categories/Pssh/"><span> Pssh</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="/link/"><i class="fa-fw fas fa-link"></i><span> 友链</span></a></div><div class="menus_item"><a class="site-page" href="/about/"><i class="fa-fw fas fa-heart"></i><span> 关于</span></a></div></div></div></div><div class="post" id="body-wrap"><header class="post-bg" id="page-header" style="background-image: url('https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg')"><nav id="nav"><span id="blog_name"><a id="site-name" href="/">SeMaik</a></span><div id="menus"><div class="menus_items"><div class="menus_item"><a class="site-page" href="/"><i class="fa-fw fas fa-home"></i><span> 首页</span></a></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> Linux</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Linux/"><span> Linux</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> WEB</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Apache/"><span> Apache</span></a></li><li><a class="site-page" href="/categories/Nginx/"><span> Nginx</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 存储</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Ceph/"><span> Ceph</span></a></li><li><a class="site-page" href="/categories/NFS/"><span> NFS</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 日志</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Loki"><span> Loki</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 编程</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Shell"><span> Shell</span></a></li><li><a class="site-page" href="/categories/Python"><span> Python</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 高可用</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/KeepAlived/"><span> KeepAlived</span></a></li><li><a class="site-page" href="/categories/LVS/"><span> LVS</span></a></li><li><a class="site-page" href="/categories/Squid/"><span> Squid</span></a></li><li><a class="site-page" href="/categories/Haproxy/"><span> Haproxy</span></a></li><li><a class="site-page" href="/categories/Rsync/"><span> Rsync</span></a></li><li><a class="site-page" href="/categories/Memcache/"><span> Memcache</span></a></li><li><a class="site-page" href="/categories/Varnish/"><span> Varnish</span></a></li><li><a class="site-page" href="/categories/GRedis/"><span> Redis</span></a></li><li><a class="site-page" href="/categories/Rabbit/"><span> RabbitMQ</span></a></li><li><a class="site-page" href="/categories/Kafka/"><span> Kafka</span></a></li><li><a class="site-page" href="/categories/MHA/"><span> MHA</span></a></li><li><a class="site-page" href="/categories/PXC/"><span> PXC</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 虚拟化</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Docker/"><span> Docker</span></a></li><li><a class="site-page" href="/categories/Kubernetes/"><span> Kubernetes</span></a></li><li><a class="site-page" href="/categories/OpenStack/"><span> OpenStack</span></a></li><li><a class="site-page" href="/categories/KVM/"><span> KVM</span></a></li><li><a class="site-page" href="/categories/Containerd"><span> Containerd</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> Hexo</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Hexo/"><span> Hexo</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 数据库</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/MySQL/"><span> MySQL</span></a></li><li><a class="site-page" href="/categories/Readis/"><span> Readis</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 微服务</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Tomcat/"><span> Tomcat</span></a></li><li><a class="site-page" href="/categories/Git/"><span> Git</span></a></li><li><a class="site-page" href="/categories/Maven/"><span> Maven</span></a></li><li><a class="site-page" href="/categories/Nexus/"><span> Nexus</span></a></li><li><a class="site-page" href="/categories/Jenkins/"><span> Jenkins</span></a></li><li><a class="site-page" href="/categories/Spring/"><span> Spring</span></a></li><li><a class="site-page" href="/categories/Consul/"><span> Consul</span></a></li><li><a class="site-page" href="/categories/Harbor/"><span> Harbor</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 自动化</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Ansible/"><span> Ansible</span></a></li><li><a class="site-page" href="/categories/Pssh/"><span> Pssh</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="/link/"><i class="fa-fw fas fa-link"></i><span> 友链</span></a></div><div class="menus_item"><a class="site-page" href="/about/"><i class="fa-fw fas fa-heart"></i><span> 关于</span></a></div></div><div id="toggle-menu"><a class="site-page"><i class="fas fa-bars fa-fw"></i></a></div></div></nav><div id="post-info"><h1 class="post-title">keepalived+NFS+rsync高可用共享存储</h1><div id="post-meta"><div class="meta-firstline"><span class="post-meta-date"><i class="far fa-calendar-alt fa-fw post-meta-icon"></i><span class="post-meta-label">发表于</span><time class="post-meta-date-created" datetime="2021-02-08T07:16:00.000Z" title="发表于 2021-02-08 15:16:00">2021-02-08</time><span class="post-meta-separator">|</span><i class="fas fa-history fa-fw post-meta-icon"></i><span class="post-meta-label">更新于</span><time class="post-meta-date-updated" datetime="2021-02-18T06:47:16.000Z" title="更新于 2021-02-18 14:47:16">2021-02-18</time></span><span class="post-meta-categories"><span class="post-meta-separator">|</span><i class="fas fa-inbox fa-fw post-meta-icon"></i><a class="post-meta-categories" href="/categories/NFS/">NFS</a></span></div><div class="meta-secondline"><span class="post-meta-separator">|</span><span class="post-meta-pv-cv"><i class="far fa-eye fa-fw post-meta-icon"></i><span class="post-meta-label">阅读量:</span><span id="busuanzi_value_page_pv"></span></span></div></div></div></header><main class="layout" id="content-inner"><div id="post"><article class="post-content" id="article-container"><h1 id="服务器信息"><a href="#服务器信息" class="headerlink" title="服务器信息"></a>服务器信息</h1><table>
<thead>
<tr>
<th align="center">IP</th>
<th align="center">Hostname</th>
<th align="center">module</th>
</tr>
</thead>
<tbody><tr>
<td align="center">172.16.1.12</td>
<td align="center">ServerOne</td>
<td align="center">nfs,rpcbind，两块或以上硬盘，keepalived，rsync+inotify</td>
</tr>
<tr>
<td align="center">172.16.1.13</td>
<td align="center">ServerTwo</td>
<td align="center">nfs,rpcbind,keepalived</td>
</tr>
<tr>
<td align="center">172.16.1.14</td>
<td align="center">client</td>
<td align="center">centos</td>
</tr>
</tbody></table>
<h2 id="部署NFS"><a href="#部署NFS" class="headerlink" title="部署NFS"></a>部署NFS</h2><blockquote>
<p>请参考前面的文档,不用配置客户端</p>
</blockquote>
<h2 id="部署keepalived主备"><a href="#部署keepalived主备" class="headerlink" title="部署keepalived主备"></a>部署keepalived主备</h2><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br></pre></td><td class="code"><pre><span class="line"># ServerOne和ServerTwo都执行</span><br><span class="line">[root@ServerOne ~]# yum -y install keepalived</span><br><span class="line">[root@ServerOne ~]# cd &#x2F;etc&#x2F;keepalived&#x2F;</span><br><span class="line">[root@ServerOne keepalived]# cp keepalived.conf keepalived.conf_bak</span><br></pre></td></tr></table></figure>
<h3 id="ServerOne配置"><a href="#ServerOne配置" class="headerlink" title="ServerOne配置"></a>ServerOne配置</h3><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br><span class="line">9</span><br><span class="line">10</span><br><span class="line">11</span><br><span class="line">12</span><br><span class="line">13</span><br><span class="line">14</span><br><span class="line">15</span><br><span class="line">16</span><br><span class="line">17</span><br><span class="line">18</span><br><span class="line">19</span><br><span class="line">20</span><br><span class="line">21</span><br><span class="line">22</span><br><span class="line">23</span><br><span class="line">24</span><br><span class="line">25</span><br><span class="line">26</span><br><span class="line">27</span><br><span class="line">28</span><br><span class="line">29</span><br><span class="line">30</span><br><span class="line">31</span><br><span class="line">32</span><br><span class="line">33</span><br><span class="line">34</span><br></pre></td><td class="code"><pre><span class="line">[root@ServerOne keepalived]# vi keepalived.conf</span><br><span class="line"></span><br><span class="line">! Configuration File for keepalived</span><br><span class="line">global_defs &#123;</span><br><span class="line">   notification_email &#123;</span><br><span class="line">     acassen@firewall.loc</span><br><span class="line">     failover@firewall.loc</span><br><span class="line">     sysadmin@firewall.loc</span><br><span class="line">   &#125;</span><br><span class="line">   notification_email_from Alexandre.Cassen@firewall.loc</span><br><span class="line">   smtp_server 192.168.200.1</span><br><span class="line">   smtp_connect_timeout 30</span><br><span class="line">   router_id MASTER		# 主 </span><br><span class="line">   vrrp_skip_check_adv_addr</span><br><span class="line">   vrrp_strict</span><br><span class="line">   vrrp_garp_interval 0</span><br><span class="line">   vrrp_gna_interval 0</span><br><span class="line">&#125;</span><br><span class="line">vrrp_instance VI_1 &#123;</span><br><span class="line">    state MASTER	# 主</span><br><span class="line">    interface ens33</span><br><span class="line">    virtual_router_id 51</span><br><span class="line">    priority 100	# 优先级</span><br><span class="line">    nopreempt	# 非抢占</span><br><span class="line">    advert_int 1</span><br><span class="line">    authentication &#123;</span><br><span class="line">        auth_type PASS</span><br><span class="line">        auth_pass 1111</span><br><span class="line">    &#125;</span><br><span class="line">    virtual_ipaddress &#123;</span><br><span class="line">        172.16.1.78		# VIP</span><br><span class="line">    &#125;</span><br><span class="line">&#125;</span><br><span class="line">[root@ServerOne keepalived]# scp keepalived.conf root@172.16.1.13:&#x2F;etc&#x2F;keepalived&#x2F;</span><br></pre></td></tr></table></figure>
<h3 id="ServerTwo配置"><a href="#ServerTwo配置" class="headerlink" title="ServerTwo配置"></a>ServerTwo配置</h3><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br></pre></td><td class="code"><pre><span class="line">[root@ServerTwokeepalived]# vi keepalived.conf</span><br><span class="line">修改：</span><br><span class="line">router_id BACKUP</span><br><span class="line">state BACKUP</span><br><span class="line">priority 90</span><br></pre></td></tr></table></figure>
<h3 id="Server主备放行防火墙"><a href="#Server主备放行防火墙" class="headerlink" title="Server主备放行防火墙"></a>Server主备放行防火墙</h3><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br></pre></td><td class="code"><pre><span class="line">vi &#x2F;etc&#x2F;firewalld&#x2F;zones&#x2F;public.xml</span><br><span class="line">  &lt;rule family&#x3D;&quot;ipv4&quot;&gt;</span><br><span class="line">    &lt;protocol value&#x3D;&quot;vrrp&quot;&#x2F;&gt;</span><br><span class="line">    &lt;accept&#x2F;&gt;</span><br><span class="line">  &lt;&#x2F;rule&gt;</span><br><span class="line">  </span><br><span class="line">firewall-cmd --reload</span><br></pre></td></tr></table></figure>
<h3 id="主备启动服务"><a href="#主备启动服务" class="headerlink" title="主备启动服务"></a>主备启动服务</h3><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br></pre></td><td class="code"><pre><span class="line">systemctl start keepalived</span><br><span class="line"># 查看VIP</span><br><span class="line">[root@ServerOne ~]# ip a | grep 1.78</span><br><span class="line">[root@ServerTwo ~]# ip a | grep 1.78</span><br><span class="line">    inet 172.16.1.78&#x2F;32 scope global ens33</span><br></pre></td></tr></table></figure>
<h3 id="编写keepalived监控脚本"><a href="#编写keepalived监控脚本" class="headerlink" title="编写keepalived监控脚本"></a>编写keepalived监控脚本</h3><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br><span class="line">9</span><br><span class="line">10</span><br><span class="line">11</span><br><span class="line">12</span><br><span class="line">13</span><br></pre></td><td class="code"><pre><span class="line">[root@ServerOne ~]# vi &#x2F;etc&#x2F;keepalived&#x2F;check_keepalived.sh</span><br><span class="line">#!&#x2F;bin&#x2F;bash</span><br><span class="line">nfsstart&#x3D;&#96;ps -ef | grep &#39;\[nfsd\]&#39; | wc -l&#96;</span><br><span class="line">if [ $nfsstart -eq 0 ];</span><br><span class="line">    then</span><br><span class="line">        systemctl restart nfs</span><br><span class="line">        retry&#x3D;&#96;ps -ef | grep &#39;\[nfsd\]&#39; | wc -l&#96;</span><br><span class="line">        if [ $retry -eq 0 ];</span><br><span class="line">            then</span><br><span class="line">                systemctl stop keepalived</span><br><span class="line">        fi</span><br><span class="line">fi</span><br><span class="line">[root@ServerOne ~]# scp &#x2F;etc&#x2F;keepalived&#x2F;check_keepalived.sh root@172.16.1.13:&#x2F;etc&#x2F;keepalived&#x2F;</span><br></pre></td></tr></table></figure>
<h2 id="配置免密登录"><a href="#配置免密登录" class="headerlink" title="配置免密登录"></a>配置免密登录</h2><blockquote>
<p>ServerOne 和 ServerTwo都做</p>
</blockquote>
<figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br></pre></td><td class="code"><pre><span class="line"># ssh-keygen</span><br><span class="line">ssh-copy -i root@172.16.1.12</span><br><span class="line">ssh-copy -i root@172.16.1.13</span><br><span class="line">ssh-copy -i root@172.16.1.14</span><br></pre></td></tr></table></figure>
<h2 id="部署rsync-inotify"><a href="#部署rsync-inotify" class="headerlink" title="部署rsync+inotify"></a>部署rsync+inotify</h2><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br></pre></td><td class="code"><pre><span class="line">[root@ServerOne ~]# tar zxf &#x2F;inotify-tools-3.14.tar.gz -C &#x2F;usr&#x2F;src</span><br><span class="line">[root@ServerOne ~]# cd &#x2F;usr&#x2F;src&#x2F;inotify-tools-3.14&#x2F;</span><br><span class="line">[root@ServerOne inotify-tools-3.14]# .&#x2F;configure --prefix&#x3D;&#x2F;usr&#x2F;local&#x2F;inotify &amp;&amp; make &amp;&amp; make install</span><br><span class="line">[root@ServerOne inotify-tools-3.14]# ln -s &#x2F;usr&#x2F;local&#x2F;inotify&#x2F;bin&#x2F;* &#x2F;usr&#x2F;local&#x2F;bin&#x2F;</span><br></pre></td></tr></table></figure>
<h3 id="编写实时同步脚本"><a href="#编写实时同步脚本" class="headerlink" title="编写实时同步脚本"></a>编写实时同步脚本</h3><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br><span class="line">9</span><br><span class="line">10</span><br><span class="line">11</span><br><span class="line">12</span><br><span class="line">13</span><br><span class="line">14</span><br><span class="line">15</span><br><span class="line">16</span><br></pre></td><td class="code"><pre><span class="line">[root@ServerOne ~]# cd &#x2F;etc&#x2F;keepalived&#x2F;</span><br><span class="line">[root@ServerOne keepalive]# vi rsync.sh</span><br><span class="line">#!&#x2F;bin&#x2F;bash</span><br><span class="line">SrcPath&#x3D;&#x2F;datanfs&#x2F;</span><br><span class="line">DestPath&#x3D;&#x2F;datanfs&#x2F;</span><br><span class="line">BackupServerone&#x3D;172.16.1.13</span><br><span class="line">#BackupServertwo&#x3D;172.16.1.100</span><br><span class="line">inotifywait -mrq --format %w%f -e create,delete,close_write $SrcPath | while read line;</span><br><span class="line">  do</span><br><span class="line">     if [ -f  $line ];</span><br><span class="line">        then</span><br><span class="line">            rsync -a --delete $SrcPath root@$&#123;BackupServerone&#125;:$DestPath</span><br><span class="line">     else</span><br><span class="line">            rsync -a --delete $SrcPath root@$&#123;BackupServerone&#125;:$DestPath</span><br><span class="line">     fi</span><br><span class="line">  done</span><br></pre></td></tr></table></figure>
<h3 id="运行脚本测试"><a href="#运行脚本测试" class="headerlink" title="运行脚本测试"></a>运行脚本测试</h3><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br><span class="line">9</span><br></pre></td><td class="code"><pre><span class="line">[root@ServerOne keepalive]# sh &#x2F;etc&#x2F;keepalived&#x2F;rsync.sh &amp;</span><br><span class="line">[root@ServerOne keepalive]# ps -ef | grep rsync.sh</span><br><span class="line">root      47252 112299  0 14:50 pts&#x2F;1    00:00:00 sh &#x2F;etc&#x2F;keepalived&#x2F;rsync.sh</span><br><span class="line">[root@ServerOne datanfs]# echo &quot;2021&#x2F;02&#x2F;08 test rsync&quot; &gt; 20210208test.txt</span><br><span class="line">[root@ServerOne datanfs]# ls</span><br><span class="line">20210208test.txt</span><br><span class="line"># 备机验证</span><br><span class="line">[root@ServerTwo datanfs]# ls</span><br><span class="line">20210208test.txt</span><br></pre></td></tr></table></figure>
<h3 id="编写检查rsync同步脚本"><a href="#编写检查rsync同步脚本" class="headerlink" title="编写检查rsync同步脚本"></a>编写检查rsync同步脚本</h3><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br></pre></td><td class="code"><pre><span class="line">[root@server1 keepalived]# vi &#x2F;etc&#x2F;keepalived&#x2F;check_rsync.sh</span><br><span class="line">CheckRsync&#x3D;&#96;ps -ef | grep &#39;sh &#x2F;etc&#x2F;keepalived&#x2F;rsync.sh&#39; | grep -v auto | wc -l&#96;</span><br><span class="line">if [ $CheckRsync -eq 0 ];</span><br><span class="line">    then</span><br><span class="line">        sh &#x2F;etc&#x2F;keepalived&#x2F;rsync.sh &gt;&amp; &#x2F;etc&#x2F;keepalived&#x2F;rsync.log</span><br><span class="line">fi</span><br></pre></td></tr></table></figure>
<h3 id="将检测脚本写入到任务定时器中"><a href="#将检测脚本写入到任务定时器中" class="headerlink" title="将检测脚本写入到任务定时器中"></a>将检测脚本写入到任务定时器中</h3><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br></pre></td><td class="code"><pre><span class="line"># ServerOne</span><br><span class="line">[root@ServerOne ~]# crontab -e</span><br><span class="line">* * * * * &#x2F;bin&#x2F;bash &#x2F;etc&#x2F;keepalived&#x2F;check_keepalived.sh &amp;</span><br><span class="line">* * * * * &#x2F;bin&#x2F;bash &#x2F;etc&#x2F;keepalived&#x2F;check_rsync &amp;</span><br><span class="line"></span><br><span class="line"># ServerTwo</span><br><span class="line">[root@ServerTwo ~]# crontab -e</span><br><span class="line">* * * * * &#x2F;bin&#x2F;bash &#x2F;etc&#x2F;keepalived&#x2F;check_keepalived.sh</span><br></pre></td></tr></table></figure>
<h2 id="客户端验证"><a href="#客户端验证" class="headerlink" title="客户端验证"></a>客户端验证</h2><h3 id="创建存储目录"><a href="#创建存储目录" class="headerlink" title="创建存储目录"></a>创建存储目录</h3><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br></pre></td><td class="code"><pre><span class="line">[root@client~]# mkdir &#x2F;datanfs_test</span><br><span class="line">[root@client~]# mount -t nfs 172.16.1.78:&#x2F;datanfs &#x2F;datanfs_test&#x2F;</span><br><span class="line">[root@client~]# df -hT | grep datanfs</span><br><span class="line">172.16.1.78:&#x2F;datanfs nfs4       20G   33M   20G    1% &#x2F;datanfs_test</span><br></pre></td></tr></table></figure>
<h3 id="Server端写入数据验证"><a href="#Server端写入数据验证" class="headerlink" title="Server端写入数据验证"></a>Server端写入数据验证</h3><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br></pre></td><td class="code"><pre><span class="line">[root@ServerOne datanfs]# echo &quot;Client test&quot; &gt; Client_test.txt</span><br><span class="line">[root@ServerOne datanfs]# ls</span><br><span class="line">20210208test.txt  Client_test.txt</span><br><span class="line"># client查看</span><br><span class="line">[root@client ~]# cd &#x2F;datanfs_test&#x2F;</span><br><span class="line">[root@client datanfs_test]# ls</span><br><span class="line">Client_test.txt</span><br></pre></td></tr></table></figure>
<h2 id="模拟故障"><a href="#模拟故障" class="headerlink" title="模拟故障"></a>模拟故障</h2><h3 id="关闭ServerTwo节点keepalived服务"><a href="#关闭ServerTwo节点keepalived服务" class="headerlink" title="关闭ServerTwo节点keepalived服务"></a>关闭ServerTwo节点keepalived服务</h3><blockquote>
<p>VIP地址会漂移到ServerOne节点上</p>
</blockquote>
<figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br></pre></td><td class="code"><pre><span class="line">[root@ServerTwo ~]# systemctl stop keepalived</span><br><span class="line">[root@ServerTwo ~]# ps -ef | grep keepalived | grep -v auto</span><br><span class="line">[root@ServerTwo ~]# ip a | grep 1.78</span><br><span class="line"># VIP地址已不存在</span><br></pre></td></tr></table></figure>
<h3 id="查看VIP地址是否漂移到ServerOne节点上"><a href="#查看VIP地址是否漂移到ServerOne节点上" class="headerlink" title="查看VIP地址是否漂移到ServerOne节点上"></a>查看VIP地址是否漂移到ServerOne节点上</h3><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br></pre></td><td class="code"><pre><span class="line">[root@ServerOne ~]# ip a| grep 1.78</span><br><span class="line">    inet 172.16.1.78&#x2F;32 scope global ens33</span><br></pre></td></tr></table></figure>
<h3 id="Client节点"><a href="#Client节点" class="headerlink" title="Client节点"></a>Client节点</h3><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br></pre></td><td class="code"><pre><span class="line"># 卸载挂载点</span><br><span class="line">[root@client ~]# umount -l &#x2F;datanfs_test</span><br></pre></td></tr></table></figure>
<blockquote>
<p>umount不加参数卸不掉，需要加参数 -l<br>-l :立即断开文件系统</p>
</blockquote>
<h3 id="重新挂载"><a href="#重新挂载" class="headerlink" title="重新挂载"></a>重新挂载</h3><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br></pre></td><td class="code"><pre><span class="line">[root@client ~]# mount -t nfs 172.16.1.78:&#x2F;datanfs &#x2F;datanfs_test&#x2F;</span><br><span class="line">[root@client ~]# df -hT | grep datanfs</span><br><span class="line">172.16.1.78:&#x2F;datanfs nfs4       20G   33M   20G    1% &#x2F;datanfs_test</span><br><span class="line">[root@client datanfs_test]# ls</span><br><span class="line">Client_test.txt</span><br><span class="line"># 数据正常存在！</span><br></pre></td></tr></table></figure>
<h1 id="附带"><a href="#附带" class="headerlink" title="附带"></a>附带</h1><blockquote>
<p>Server端keepalived主备切换之后，Client端需要重新挂载nfs共享存储！使用以下脚本可以解决手动卸载与挂载的问题</p>
</blockquote>
<h2 id="client自动卸载与挂载共享目录脚本"><a href="#client自动卸载与挂载共享目录脚本" class="headerlink" title="client自动卸载与挂载共享目录脚本"></a>client自动卸载与挂载共享目录脚本</h2><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br><span class="line">9</span><br><span class="line">10</span><br><span class="line">11</span><br><span class="line">12</span><br><span class="line">13</span><br><span class="line">14</span><br><span class="line">15</span><br></pre></td><td class="code"><pre><span class="line">#!&#x2F;bin&#x2F;bash</span><br><span class="line">#!&#x2F;usr&#x2F;bin&#x2F;expect</span><br><span class="line">check_kp&#x3D;&#96;ps -ef | grep &#39;keepalived -D&#39; | grep -v auto | wc -l&#96;</span><br><span class="line">if [ $check_kp -eq 0 ];</span><br><span class="line">    then</span><br><span class="line">        expect -c &quot;</span><br><span class="line">        spawn ssh root@172.16.1.14</span><br><span class="line">        expect \&quot;#\&quot;</span><br><span class="line">        send \&quot;umount -l &#x2F;datanfs_test\r\&quot;</span><br><span class="line">        expect \&quot;#\&quot;</span><br><span class="line">        send \&quot;mount -t nfs 172.16.1.78:&#x2F;datanfs &#x2F;datanfs_test\r\&quot;</span><br><span class="line">        expect \&quot;#\&quot;</span><br><span class="line">        send \&quot;exit\r\&quot;</span><br><span class="line">        interact&quot;</span><br><span class="line">fi</span><br></pre></td></tr></table></figure></article><div class="post-copyright"><div class="post-copyright__author"><span class="post-copyright-meta">文章作者: </span><span class="post-copyright-info"><a href="mailto:undefined">ZuSir</a></span></div><div class="post-copyright__type"><span class="post-copyright-meta">文章链接: </span><span class="post-copyright-info"><a href="http://example.com/2021/02/08/keepalived-NFS-rsyns%E9%AB%98%E5%8F%AF%E7%94%A8%E5%85%B1%E4%BA%AB%E5%AD%98%E5%82%A8/">http://example.com/2021/02/08/keepalived-NFS-rsyns%E9%AB%98%E5%8F%AF%E7%94%A8%E5%85%B1%E4%BA%AB%E5%AD%98%E5%82%A8/</a></span></div><div class="post-copyright__notice"><span class="post-copyright-meta">版权声明: </span><span class="post-copyright-info">本博客所有文章除特别声明外，均采用 <a href="https://creativecommons.org/licenses/by-nc-sa/4.0/" target="_blank">CC BY-NC-SA 4.0</a> 许可协议。转载请注明来自 <a href="http://example.com" target="_blank">SeMaik</a>！</span></div></div><div class="tag_share"><div class="post-meta__tag-list"></div><div class="post_share"><div class="social-share" data-image="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg" data-sites="facebook,twitter,wechat,weibo,qq"></div><link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/social-share.js/dist/css/share.min.css" media="print" onload="this.media='all'"><script src="https://cdn.jsdelivr.net/npm/social-share.js/dist/js/social-share.min.js" defer></script></div></div><nav class="pagination-post" id="pagination"><div class="prev-post pull-left"><a href="/2021/02/09/Samba%E6%96%87%E4%BB%B6%E5%85%B1%E4%BA%AB/"><img class="prev-cover" src="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg" onerror="onerror=null;src='/img/123.jpeg'" alt="cover of previous post"><div class="pagination-info"><div class="label">上一篇</div><div class="prev_info">Samba</div></div></a></div><div class="next-post pull-right"><a href="/2021/02/08/Untitled/"><img class="next-cover" src="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg" onerror="onerror=null;src='/img/123.jpeg'" alt="cover of next post"><div class="pagination-info"><div class="label">下一篇</div><div class="next_info">NFS共享存储</div></div></a></div></nav></div><div class="aside-content" id="aside-content"><div class="card-widget card-info"><div class="card-info-avatar is-center"><img class="avatar-img" src="/img/123.jpeg" onerror="this.onerror=null;this.src='/img/123.jpeg'" alt="avatar"/><div class="author-info__name">ZuSir</div><div class="author-info__description">一个收藏回忆与分享技术的地方!</div></div><div class="card-info-data"><div class="card-info-data-item is-center"><a href="/archives/"><div class="headline">文章</div><div class="length-num">152</div></a></div><div class="card-info-data-item is-center"><a href="/categories/"><div class="headline">分类</div><div class="length-num">37</div></a></div></div></div><div class="card-widget card-announcement"><div class="item-headline"><i class="fas fa-bullhorn card-announcement-animation"></i><span>公告</span></div><div class="announcement_content">This is my Blog! <img src="https://ss0.bdstatic.com/70cFuHSh_Q1YnxGkpoWK1HF6hhy/it/u=3894415926,2787041726&fm=26&gp=0.jpg"></div></div><div class="sticky_layout"><div class="card-widget" id="card-toc"><div class="item-headline"><i class="fas fa-stream"></i><span>目录</span></div><div class="toc-content"><ol class="toc"><li class="toc-item toc-level-1"><a class="toc-link" href="#%E6%9C%8D%E5%8A%A1%E5%99%A8%E4%BF%A1%E6%81%AF"><span class="toc-number">1.</span> <span class="toc-text">服务器信息</span></a><ol class="toc-child"><li class="toc-item toc-level-2"><a class="toc-link" href="#%E9%83%A8%E7%BD%B2NFS"><span class="toc-number">1.1.</span> <span class="toc-text">部署NFS</span></a></li><li class="toc-item toc-level-2"><a class="toc-link" href="#%E9%83%A8%E7%BD%B2keepalived%E4%B8%BB%E5%A4%87"><span class="toc-number">1.2.</span> <span class="toc-text">部署keepalived主备</span></a><ol class="toc-child"><li class="toc-item toc-level-3"><a class="toc-link" href="#ServerOne%E9%85%8D%E7%BD%AE"><span class="toc-number">1.2.1.</span> <span class="toc-text">ServerOne配置</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#ServerTwo%E9%85%8D%E7%BD%AE"><span class="toc-number">1.2.2.</span> <span class="toc-text">ServerTwo配置</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#Server%E4%B8%BB%E5%A4%87%E6%94%BE%E8%A1%8C%E9%98%B2%E7%81%AB%E5%A2%99"><span class="toc-number">1.2.3.</span> <span class="toc-text">Server主备放行防火墙</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#%E4%B8%BB%E5%A4%87%E5%90%AF%E5%8A%A8%E6%9C%8D%E5%8A%A1"><span class="toc-number">1.2.4.</span> <span class="toc-text">主备启动服务</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#%E7%BC%96%E5%86%99keepalived%E7%9B%91%E6%8E%A7%E8%84%9A%E6%9C%AC"><span class="toc-number">1.2.5.</span> <span class="toc-text">编写keepalived监控脚本</span></a></li></ol></li><li class="toc-item toc-level-2"><a class="toc-link" href="#%E9%85%8D%E7%BD%AE%E5%85%8D%E5%AF%86%E7%99%BB%E5%BD%95"><span class="toc-number">1.3.</span> <span class="toc-text">配置免密登录</span></a></li><li class="toc-item toc-level-2"><a class="toc-link" href="#%E9%83%A8%E7%BD%B2rsync-inotify"><span class="toc-number">1.4.</span> <span class="toc-text">部署rsync+inotify</span></a><ol class="toc-child"><li class="toc-item toc-level-3"><a class="toc-link" href="#%E7%BC%96%E5%86%99%E5%AE%9E%E6%97%B6%E5%90%8C%E6%AD%A5%E8%84%9A%E6%9C%AC"><span class="toc-number">1.4.1.</span> <span class="toc-text">编写实时同步脚本</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#%E8%BF%90%E8%A1%8C%E8%84%9A%E6%9C%AC%E6%B5%8B%E8%AF%95"><span class="toc-number">1.4.2.</span> <span class="toc-text">运行脚本测试</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#%E7%BC%96%E5%86%99%E6%A3%80%E6%9F%A5rsync%E5%90%8C%E6%AD%A5%E8%84%9A%E6%9C%AC"><span class="toc-number">1.4.3.</span> <span class="toc-text">编写检查rsync同步脚本</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#%E5%B0%86%E6%A3%80%E6%B5%8B%E8%84%9A%E6%9C%AC%E5%86%99%E5%85%A5%E5%88%B0%E4%BB%BB%E5%8A%A1%E5%AE%9A%E6%97%B6%E5%99%A8%E4%B8%AD"><span class="toc-number">1.4.4.</span> <span class="toc-text">将检测脚本写入到任务定时器中</span></a></li></ol></li><li class="toc-item toc-level-2"><a class="toc-link" href="#%E5%AE%A2%E6%88%B7%E7%AB%AF%E9%AA%8C%E8%AF%81"><span class="toc-number">1.5.</span> <span class="toc-text">客户端验证</span></a><ol class="toc-child"><li class="toc-item toc-level-3"><a class="toc-link" href="#%E5%88%9B%E5%BB%BA%E5%AD%98%E5%82%A8%E7%9B%AE%E5%BD%95"><span class="toc-number">1.5.1.</span> <span class="toc-text">创建存储目录</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#Server%E7%AB%AF%E5%86%99%E5%85%A5%E6%95%B0%E6%8D%AE%E9%AA%8C%E8%AF%81"><span class="toc-number">1.5.2.</span> <span class="toc-text">Server端写入数据验证</span></a></li></ol></li><li class="toc-item toc-level-2"><a class="toc-link" href="#%E6%A8%A1%E6%8B%9F%E6%95%85%E9%9A%9C"><span class="toc-number">1.6.</span> <span class="toc-text">模拟故障</span></a><ol class="toc-child"><li class="toc-item toc-level-3"><a class="toc-link" href="#%E5%85%B3%E9%97%ADServerTwo%E8%8A%82%E7%82%B9keepalived%E6%9C%8D%E5%8A%A1"><span class="toc-number">1.6.1.</span> <span class="toc-text">关闭ServerTwo节点keepalived服务</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#%E6%9F%A5%E7%9C%8BVIP%E5%9C%B0%E5%9D%80%E6%98%AF%E5%90%A6%E6%BC%82%E7%A7%BB%E5%88%B0ServerOne%E8%8A%82%E7%82%B9%E4%B8%8A"><span class="toc-number">1.6.2.</span> <span class="toc-text">查看VIP地址是否漂移到ServerOne节点上</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#Client%E8%8A%82%E7%82%B9"><span class="toc-number">1.6.3.</span> <span class="toc-text">Client节点</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#%E9%87%8D%E6%96%B0%E6%8C%82%E8%BD%BD"><span class="toc-number">1.6.4.</span> <span class="toc-text">重新挂载</span></a></li></ol></li></ol></li><li class="toc-item toc-level-1"><a class="toc-link" href="#%E9%99%84%E5%B8%A6"><span class="toc-number">2.</span> <span class="toc-text">附带</span></a><ol class="toc-child"><li class="toc-item toc-level-2"><a class="toc-link" href="#client%E8%87%AA%E5%8A%A8%E5%8D%B8%E8%BD%BD%E4%B8%8E%E6%8C%82%E8%BD%BD%E5%85%B1%E4%BA%AB%E7%9B%AE%E5%BD%95%E8%84%9A%E6%9C%AC"><span class="toc-number">2.1.</span> <span class="toc-text">client自动卸载与挂载共享目录脚本</span></a></li></ol></li></ol></div></div><div class="card-widget card-recent-post"><div class="item-headline"><i class="fas fa-history"></i><span>最新文章</span></div><div class="aside-list"><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94%E9%83%A8%E7%BD%B2Zabbix-Server5-0/" title="Shell程序——部署Zabbix-ServerV5.0">Shell程序——部署Zabbix-ServerV5.0</a><time datetime="2022-02-17T03:32:00.000Z" title="发表于 2022-02-17 11:32:00">2022-02-17</time></div></div><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94%E9%83%A8%E7%BD%B2Harbor/" title="Shell程序——部署Harbor">Shell程序——部署Harbor</a><time datetime="2022-02-17T03:31:00.000Z" title="发表于 2022-02-17 11:31:00">2022-02-17</time></div></div><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94Mysql%E5%A4%87%E4%BB%BD/" title="Shell程序——Mysql备份">Shell程序——Mysql备份</a><time datetime="2022-02-17T03:30:00.000Z" title="发表于 2022-02-17 11:30:00">2022-02-17</time></div></div><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94%E6%89%B9%E9%87%8F%E4%BF%9D%E5%AD%98Docker-image/" title="Shell程序——批量保存Docker_image">Shell程序——批量保存Docker_image</a><time datetime="2022-02-17T03:29:00.000Z" title="发表于 2022-02-17 11:29:00">2022-02-17</time></div></div><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94%E5%85%A8%E6%AE%B5IP%E6%89%AB%E6%8F%8F/" title="Shell程序——全段IP扫描">Shell程序——全段IP扫描</a><time datetime="2022-02-17T03:28:00.000Z" title="发表于 2022-02-17 11:28:00">2022-02-17</time></div></div></div></div></div></div></main><footer id="footer"><div id="footer-wrap"><div class="copyright">&copy;2020 - 2022 By ZuSir</div><div class="framework-info"><span>框架 </span><a target="_blank" rel="noopener" href="https://hexo.io">Hexo</a><span class="footer-separator">|</span><span>主题 </span><a target="_blank" rel="noopener" href="https://github.com/jerryc127/hexo-theme-butterfly">Butterfly</a></div></div></footer></div><div id="rightside"><div id="rightside-config-hide"><button id="readmode" type="button" title="阅读模式"><i class="fas fa-book-open"></i></button><button id="hide-aside-btn" type="button" title="单栏和双栏切换"><i class="fas fa-arrows-alt-h"></i></button></div><div id="rightside-config-show"><button id="rightside_config" type="button" title="设置"><i class="fas fa-cog fa-spin"></i></button><button class="close" id="mobile-toc-button" type="button" title="目录"><i class="fas fa-list-ul"></i></button><button id="go-up" type="button" title="回到顶部"><i class="fas fa-arrow-up"></i></button></div></div><div><script src="/js/utils.js"></script><script src="/js/main.js"></script><div class="js-pjax"></div><script defer="defer" id="fluttering_ribbon" mobile="true" src="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/dist/canvas-fluttering-ribbon.min.js"></script><script async data-pjax src="//busuanzi.ibruce.info/busuanzi/2.3/busuanzi.pure.mini.js"></script></div></body></html>